<?php

namespace Drupal\sqrl\Plugin\SqrlAction;

use Drupal\Core\Entity\EntityStorageException;
use Drupal\sqrl\Entity\Identity;
use Drupal\sqrl\SqrlActionPluginBase;

/**
 * Plugin implementation of the sqrl action "setkey".
 *
 * @SqrlAction(
 *   id = "setkey",
 *   label = @Translation("Set key"),
 *   description = @Translation("TBD.")
 * )
 */
class SetKey extends SqrlActionPluginBase {

  /**
   * {@inheritdoc}
   */
  public function run(): bool {
    if (!$this->user) {
      return FALSE;
    }
    if ($this->identities->getIdentityByIdk($this->user->id())) {
      // Nothing changed and we have nothing to do.
      return TRUE;
    }
    if ($identity = $this->identities->getIdentityByIdk()) {
      $identity->addUser($this->user);
    }
    else {
      $identity = Identity::create([
        'idk' => $this->client->getClientVar('idk'),
        'suk' => $this->client->getClientVar('suk'),
        'vuk' => $this->client->getClientVar('vuk'),
        'user' => $this->user,
        'status' => TRUE,
      ]);
    }
    try {
      if ($identity->save()) {
        $this->client->setResponse('suk', $this->client->getClientVar('suk'));
        $this->client->setResponse('vuk', $this->client->getClientVar('vuk'));
        return TRUE;
      }
    } catch (EntityStorageException $e) {
    }
    return FALSE;
  }

}
